@import '@gitlab/ui/src/scss/gitlab_ui';
@import '@gitlab/ui/src/scss/utilities';

@tailwind base;
@tailwind components;
@tailwind utilities;

// Variables and root-level styles
:root {
  --font-family: var(--editor-font-family);
  --glDuoChat-font-family-code: var(--editor-font-family); // --monaco-monospace-font

  --glDuoChat-foreground: var(--editor-foreground);
  --glDuoChat-foreground-muted: var(--editor-foreground--muted);
  --glDuoChat-foreground-disabled: var(--editor-foreground--disabled);

  --glDuoChat-background: var(--editor-background);
  --glDuoChat-background-alternative: var(--editor-background);

  --glDuoChat-border-color: var(--editor-border);
  --glDuoChat-shadow: var(--vscode-widget-shadow);

  --glDuoChat-alert-foreground: var(--vscode-sideBarTitle-foreground);
  --glDuoChat-alert-background: var(--vscode-sideBarSectionHeader-background);
  --glDuoChat-alert-border-color: var(--vscode-sideBarSectionHeader-border);

  --glDuoChat-border-radius: 2px;
  --glDuoChat-feedback-alert-color: #333238;
  --gl-feedback-danger-icon-color: var(--vscode-errorForeground);
  --gl-alert-danger-title-color: var(--vscode-errorForeground);

  --gl-background-color-overlap: rgb(from var(--vscode-badge-background) r g b / 1); // prevent transparency / alpha from theme variable being applied to background
  --glDuoChat-popover-foreground: var(--vscode-badge-foreground);
  --glDuoChat-token-foreground: var(--vscode-badge-foreground);
  --glDuoChat-token-background: var(--vscode-badge-background);

  --glDuoChat-icon-foreground: var(--vscode-icon-foreground);

  --glDuoChat-textLink-foreground: var(--editor-link-foreground);
  --glDuoChat-textLink-foreground-active: var(--editor-link-foreground); // TODO: Add new theme property
  --glDuoChat-textPreformat-foreground: var(--vscode-textPreformat-foreground);
  --glDuoChat-textPreformat-background: var(--vscode-textCodeBlock-background);

  --glDuoChat-input-border: var(--editor-input-border);
  --glDuoChat-input-background: var(--editor-input-background);
  --glDuoChat-input-foreground: var(--editor-input-foreground);
  --glDuoChat-input-placeholder-foreground: var(--editor-input-foreground);
  --glDuoChat-input-border-focus: var(--vscode-focusBorder);
  --glDuoChat-input-background-focus: var(--editor-input-background--focus);
  --glDuoChat-input-foreground-focus: var(--editor-input-foreground--focus);

  --glDuoChat-checkbox-background: var(--vscode-checkbox-background);
  --glDuoChat-checkbox-border: var(--vscode-checkbox-border);
  --glDuoChat-checkbox-background-selected: var(--vscode-checkbox-selectBackground);
  --glDuoChat-checkbox-border-selected: var(--vscode-checkbox-selectBorder);

  --glDuoChat-button-foreground: var(--editor-button-foreground);
  --glDuoChat-button-background: var(--editor-button-background);
  --glDuoChat-button-border: var(--editor-button-border);
  --glDuoChat-button-background-hover: var(--editor-button-background--hover);

  --glDuoChat-buttonSecondary-foreground: var(--vscode-button-secondaryForeground);
  --glDuoChat-buttonSecondary-background: var(--vscode-button-secondaryBackground);
  --glDuoChat-buttonSecondary-background-hover: var(--vscode-button-secondaryHoverBackground);

  --glDuoChat-list-background: var(--vscode-dropdown-background);
  --glDuoChat-list-foreground: var(--vscode-dropdown-foreground);
  --glDuoChat-list-border: var(--vscode-dropdown-border);
  --glDuoChat-list-background-active: var(--vscode-list-activeSelectionBackground);
  --glDuoChat-list-foreground-active: var(--vscode-list-activeSelectionForeground);
}
body {
  @include gl-p-0;
}
a,
.gl-link {
  @extend %link-colors;
}
%link-colors {
  color: var(--glDuoChat-textLink-foreground);
  &:hover {
    color: var(--glDuoChat-textLink-foreground);
  }
  &:focus,
  &:active:focus {
    @include gl-shadow-none;
    @include gl-text-decoration-none;
    color: var(--glDuoChat-textLink-foreground-active);
  }
}
// This `.duo-chat-message` style overrides the gitlab-ui style for chat message that's ATM incompatible with VS Code
.duo-chat-message pre {
  @include gl-shadow-none;
  background-color: var(--glDuoChat-textPreformat-background);
  color: var(--glDuoChat-textPreformat-foreground);
  border-radius: var(--glDuoChat-border-radius);
}
.duo-chat-message pre code  {
  background-color: inherit;
  color: inherit;
}

.duo-chat-message .code {
  background-color: var(--glDuoChat-textPreformat-background);
  color: var(--glDuoChat-textPreformat-foreground);
}

// gitlab-ui utils overrides
.gl-animate-skeleton-loader {
  background-color: var(--glDuoChat-foreground-muted);

  background-image: linear-gradient(to right,
    var(--glDuoChat-foreground-muted) 0,
    var(--glDuoChat-foreground) 23%,
    var(--glDuoChat-foreground) 27%,
    var(--glDuoChat-foreground-muted) 50%
  );
}
.gl-alert-body {
  color: var(--glDuoChat-feedback-alert-color);
}
.gl-token {
  color: var(--glDuoChat-token-foreground);
  background-color: var(--glDuoChat-token-background);
  border-radius: var(--glDuoChat-border-radius);
  border-color: var(--glDuoChat-border-color);

  .gl-token-content .gl-icon {
    color: var(--glDuoChat-token-foreground);
  }
}
.gl-popover {
  .popover-header,
  .popover-body,
  .gl-text-subtle {
    color: var(--glDuoChat-popover-foreground);
  }

  .gl-fill-icon-subtle {
    fill: var(--glDuoChat-popover-foreground);
  }
}

// TODO: Remove .gl-drawer once @gitlab/ui is upgraded to v87 or later.
// https://gitlab.com/gitlab-org/gitlab-vscode-extension/-/merge_requests/1760#note_2022529088
.gl-drawer .gl-drawer-header-sticky, .duo-chat-drawer .duo-chat-drawer-header-sticky {
  background-color: var(--glDuoChat-background-alternative);
}
.drawer-title {
  @include gl-display-none;
}
.gl-bg-gray-10 {
  background: var(--glDuoChat-background);
}
.gl-bg-gray-50 {
  background: var(--glDuoChat-alert-background);
}
.gl-text-gray-700 {
  color: var(--glDuoChat-alert-foreground);
}
.gl-border-t {
  border-color: var(--glDuoChat-border-color);
}
.gl-rounded-base,
.gl-button.gl-button,
.gl-rounded-lg {
  border-radius: var( --glDuoChat-border-radius);
  &:focus,
  &:hover,
  &:active:focus {
    border-radius: var( --glDuoChat-border-radius);
  }
}
.gl-rounded-base\! {
  border-radius: var( --glDuoChat-border-radius) !important;
  &:hover {
    border-radius: var( --glDuoChat-border-radius) !important;
  }
}
.gl-rounded-bottom-right-none {
  @include gl-rounded-bottom-right-none;
}
.gl-rounded-bottom-left-none {
  @include gl-rounded-bottom-left-none;
}
.gl-rounded-top-left-none {
  @include gl-rounded-top-left-none;
}
.gl-rounded-top-right-none {
  @include gl-rounded-top-right-none;
}
.gl-bg-white {
  background: var(--glDuoChat-background);
}
.gl-inset-border-1-gray-400 {
  box-shadow: inset 0 0 0 1px var(--glDuoChat-input-border);
  &:focus-within {
    @include gl-shadow-none;
    outline: 1px solid var(--glDuoChat-input-border-focus);
  }
}
.gl-icon {
  color: var(--glDuoChat-icon-foreground);
}
.gl-button .gl-icon {
  color: var(--glDuoChat-button-foreground);
}
.gl-button.gl-button.btn-default,
.gl-button.gl-button.btn-dashed,
.gl-button.gl-button.btn-block.btn-default,
.gl-button.gl-button.btn-block.btn-dashed {
  background-color: var(--glDuoChat-button-background);
  .gl-icon {
    color: var(--glDuoChat-button-foreground);
  }
  &:hover,
  &:focus {
    background: var(--glDuoChat-button-background);
    color: var(--glDuoChat-button-foreground);
    .gl-icon {
      color: var(--glDuoChat-button-foreground);
    }
  }
}
.gl-button.gl-button.btn-confirm-secondary {
  background: var(--glDuoChat-buttonSecondary-background);
  color: var(--glDuoChat-buttonSecondary-foreground);
  box-shadow: inset 0 0 0 1px var(--glDuoChat-button-border);
  &:focus,
  &:hover,
  &:active:focus {
    background: var(--glDuoChat-buttonSecondary-background-hover);
    color: var(--glDuoChat-buttonSecondary-foreground);
    box-shadow: inset 0 0 0 1px var(--glDuoChat-input-border-focus);
  }
}
.gl-button.gl-button.btn-confirm {
  background: var(--glDuoChat-button-background);
  color: var(--glDuoChat-button-foreground);
  box-shadow: inset 0 0 0 1px var(--glDuoChat-button-border);
  &:focus,
  &:hover,
  &:active:focus {
    background: var(--glDuoChat-button-background-hover);
    color: var(--glDuoChat-button-foreground);
    box-shadow: inset 0 0 0 1px var(--glDuoChat-input-border-focus);
  }
}
.gl-button.gl-button.btn-link {
  @extend %link-colors;
}
.gl-button.gl-button.btn-default-tertiary,
.gl-button.gl-button.btn-dashed-tertiary,
.gl-button.gl-button.btn-confirm-tertiary,
.gl-button.gl-button.btn-info-tertiary,
.gl-button.gl-button.btn-success-tertiary,
.gl-button.gl-button.btn-danger-tertiary,
.gl-button.gl-button.btn-block.btn-default-tertiary,
.gl-button.gl-button.btn-block.btn-dashed-tertiary,
.gl-button.gl-button.btn-block.btn-confirm-tertiary,
.gl-button.gl-button.btn-block.btn-info-tertiary,
.gl-button.gl-button.btn-block.btn-success-tertiary,
.gl-button.gl-button.btn-block.btn-danger-tertiary {
  mix-blend-mode: normal;
}
.text-muted {
  color: var(--glDuoChat-foreground-muted) !important;
}
.gl-text-blue-900 {
  color: var(--glDuoChat-foreground);
}
.gl-bg-blue-100 {
  background: var(--glDuoChat-background-alternative);
}
.gl-text-gray-500,
.gl-text-subtle {
  color: var(--glDuoChat-foreground-muted);

  .gl-icon {
    color: var(--glDuoChat-foreground-muted);
  }
}
.gl-text-gray-600 {
  color: var(--glDuoChat-foreground);
}
.gl-text-gray-900 {
  color: var(--glDuoChat-foreground);
  &:active {
    color: var(--glDuoChat-foreground);
  }
}
.gl-border-gray-50 {
  border-color: var(--glDuoChat-border-color);
}
.gl-markdown {
  color: var(--glDuoChat-foreground);
  font-family: var(--font-family);
  code {
    background: var(--glDuoChat-textPreformat-background);
    color: var(--glDuoChat-textPreformat-foreground);
    font-family: var(--glDuoChat-font-family-code);
    border-radius: 4px;
  }
  pre code {
    @include gl-bg-transparent;
    color: var(--glDuoChat-textPreformat-foreground);
  }
  &:first-child {
    pre {
      @include gl-mt-0;
    }
  }
}
.gl-modal {
  color: var(--glDuoChat-foreground);
  .modal-content {
    background-color: var(--glDuoChat-background-alternative);
    border-color: var(--glDuoChat-border-color);
    border-radius: var( --glDuoChat-border-radius);
    box-shadow: 0 4px 16px var(--glDuoChat-shadow);
  }
  .modal-header {
    background-color: var(--glDuoChat-background-alternative);
    & > :first-child {
      border-top-left-radius: 2px;
      border-top-right-radius: 2px;
    }
  }
  .modal-body {
    background-color: var(--glDuoChat-background-alternative);
  }
}
.gl-form-checkbox,
.gl-form-radio {
  color: var(--glDuoChat-foreground);
}
.gl-form-input,
.gl-form-input.form-control {
  background: var(--glDuoChat-input-background);
  color: var(--glDuoChat-input-foreground);
  box-shadow: inset 0 0 0 1px var(--glDuoChat-input-border);
  &:focus,
  &:not(.form-control-plaintext):focus {
    background: var(--glDuoChat-input-background-focus);
    color: var(--glDuoChat-input-foreground-focus);
    box-shadow: inset 0 0 0 1px var(--glDuoChat-input-border-focus);
  }
  &::placeholder {
    color: var(--glDuoChat-input-placeholder-foreground);
  }
}
.modal-backdrop {
  opacity: 1;
  background-color: var(--glDuoChat-shadow);
}
.gl-form-checkbox,
.gl-form-radio {

  &.custom-control {

    .custom-control-input ~ .custom-control-label {
      &::before {
        border-color: var(--glDuoChat-checkbox-border);
        background-color: var(--glDuoChat-checkbox-background);
      }
    }

    .custom-control-input:not(:disabled):focus ~ .custom-control-label {
      &::before {
        @include gl-shadow-none;
        border-color: var(--glDuoChat-checkbox-border);
      }
    }

    .custom-control-input:checked ~ .custom-control-label {
      &::before {
        border-color: var(--glDuoChat-checkbox-border-selected);
        background-color: var(--glDuoChat-checkbox-background-selected);
      }
    }

    .custom-control-input[type='checkbox']:checked ~ .custom-control-label,
    .custom-control-input[type='checkbox']:indeterminate ~ .custom-control-label,
    .custom-control-input[type='radio']:checked ~ .custom-control-label {
      &::after {
        mask-image: none;
        background-color: var(--glDuoChat-button-background);
        border-radius: var( --glDuoChat-border-radius);
      }
    }

    .custom-control-input:not(:disabled):checked ~ .custom-control-label:hover,
    .custom-control-input:not(:disabled):focus:checked ~ .custom-control-label {
      &::before {
        background-color: var(--glDuoChat-checkbox-background-selected);
        border-color: var(--glDuoChat-checkbox-border-selected);
      }
    }

    &.custom-checkbox {
      .custom-control-input:indeterminate ~ .custom-control-label::before {
        background-color: var(--glDuoChat-checkbox-background-selected);
        border-color: var(--glDuoChat-checkbox-border-selected);
      }

      .custom-control-input:not(:disabled):indeterminate ~ .custom-control-label:hover::before,
      .custom-control-input:not(:disabled):focus:indeterminate ~ .custom-control-label::before {
        background-color: var(--glDuoChat-checkbox-background-selected);
        border-color: var(--glDuoChat-checkbox-border-selected);
      }
    }

    .custom-control-input:disabled ~ .custom-control-label {
      &::before {
        background-color: var(--glDuoChat-foreground-disabled);
        border-color: var(--glDuoChat-checkbox-border-selected);
      }
    }

    .custom-control-input:checked:disabled ~ .custom-control-label,
    .custom-control-input[type='checkbox']:indeterminate:disabled ~ .custom-control-label {
      &::before {
        background-color: var(--glDuoChat-checkbox-background-selected);
        border-color: var(--glDuoChat-checkbox-border-selected);
      }

      &::after {
        background-color: var(--glDuoChat-foreground-disabled);
      }
    }
  }
}
.modal-dialog {
  @include gl-mr-5;
  @include gl-ml-5;
}
.gl-modal {
  .modal-footer {
    @include media-breakpoint-down(xs) {
      @include gl-flex-direction-row;

      .btn + .btn:not(.dropdown-toggle-split),
      .btn + .btn-group,
      .btn-group + .btn {
        @include gl-ml-3;
        @include gl-mt-0;
      }
    }
  }
}


// Components
.duo-chat {
  @include gl-h-100vh;
  @include gl-border-none;
  font-family: var(--font-family);
  color: var(--glDuoChat-foreground);
}
.duo-chat-input {
  background: var(--glDuoChat-input-background);
  color: var(--glDuoChat-input-foreground);

  .gl-form-input:not(.form-control-plaintext) {
    &:focus {
      color: var(--glDuoChat-input-foreground);
    }
  }
}
.duo-chat .gl-drawer-body-scrim-on-footer:before {
  background: transparent;
}
.duo-chat-loader {
  color: var(--glDuoChat-foreground);
}
.duo-chat .duo-chat-drawer-body-scrim-on-footer {
  &::before {
    background: linear-gradient(to bottom, rgba(255,255,255,0), var(--glDuoChat-background))
  }
}
.legal-warning {
  @include gl-border-t-none;
  background: var(--glDuoChat-alert-background);
  color: var(--glDuoChat-alert-foreground);
  border-color: var(--glDuoChat-alert-border-color);
  padding-top: 0.5em;
  padding-bottom: 0.5em;

  .gl-alert-body {
    color: var(--glDuoChat-alert-foreground);
  }
}
.duo-chat {
  copy-code,
  insert-code-snippet {
    background-color: var(--glDuoChat-background);

    .gl-button.gl-button.btn-default {
      background: var(--glDuoChat-textPreformat-background);

      &:hover,
      .gl-icon {
        background: var(--glDuoChat-textPreformat-background);
        color: var(--glDuoChat-textPreformat-foreground);
      }
    }
  }
}
.slash-commands {
  background-color: var(--glDuoChat-list-background);
  border-color: var(--glDuoChat-list-border);

  small {
    // Will be gone once https://gitlab.com/gitlab-org/gitlab-ui/-/issues/2429 is addressed
    @include gl-text-right;
    @include gl-pl-3;
  }

  button.dropdown-item {
    color: var(--glDuoChat-list-foreground);

    &:hover {
      color: var(--glDuoChat-list-foreground-active) !important;
    }
  }

  .active-command {
    background-color: var(--glDuoChat-list-background-active);

    button.dropdown-item {
      color: var(--glDuoChat-list-foreground-active);

      small {
        color: var(--glDuoChat-list-foreground-active);
      }
    }

    .gl-text-secondary {
      color: var(--glDuoChat-list-foreground-active);
    }
  }

  .gl-icon {
    color: inherit;
  }
}
